searchNodes=[{"doc":"This will generate a PromEx config","ref":"Mix.Tasks.PromEx.Gen.Config.html","title":"Mix.Tasks.PromEx.Gen.Config","type":"task"},{"doc":"This will generate a version diff of what is in PromEx and what's in Grafana","ref":"Mix.Tasks.PromEx.Outdated.html","title":"Mix.Tasks.PromEx.Outdated","type":"task"},{"doc":"This will publish dashboards to grafana","ref":"Mix.Tasks.PromEx.Publish.html","title":"Mix.Tasks.PromEx.Publish","type":"task"},{"doc":"PromEx is a plugin based library which can be used to capture telemetry events and report them out for consumption by Prometheus. The main purpose of this particular library is to provide the behaviour that all PromEx plugins leverage so that a consistent interface can be achieved and so that leveraging multiple plugins is effortless from the user's point of view.All metrics collection will be delegated to plugins which can be found here:Foundational metrics:[~] PromEx.Plugins.Application Application related informational metrics[~] PromEx.Plugins.Beam BEAM virtual machine metricsUpcoming Elixir library metrics:[~] Phoenix (https://hexdocs.pm/phoenix/Phoenix.Logger.html)[ ] Ecto (https://hexdocs.pm/ecto/Ecto.Repo.html#module-telemetry-events)[ ] Broadway (https://hexdocs.pm/broadway/Broadway.html#module-telemetry)[ ] Finch (https://hexdocs.pm/finch/Finch.Telemetry.html#content)Backlog Elixir library metrics:[ ] Absinthe (https://hexdocs.pm/absinthe/1.5.3/telemetry.html)[ ] Dataloader (https://hexdocs.pm/dataloader/telemetry.html)[ ] GenRMQ (https://hexdocs.pm/gen_rmq/3.0.0/GenRMQ.Publisher.Telemetry.html and https://hexdocs.pm/gen_rmq/3.0.0/GenRMQ.Consumer.Telemetry.html)[ ] Plug (https://hexdocs.pm/plug/Plug.Telemetry.html)[ ] PlugCowboy (https://hexdocs.pm/plug_cowboy/2.4.0/Plug.Cowboy.html#module-instrumentation)[ ] Redix (https://hexdocs.pm/redix/Redix.Telemetry.html)[ ] Tesla (https://hexdocs.pm/tesla/Tesla.Middleware.Telemetry.html)[ ] PhoenixLiveView (https://hexdocs.pm/phoenix_live_view/telemetry.html)[ ] Memcachex (https://hexdocs.pm/memcachex/0.5.0/Memcache.html#module-telemetry)[ ] Oban (https://hexdocs.pm/oban/Oban.Telemetry.html)[ ] Nebulex (https://hexdocs.pm/nebulex/2.0.0-rc.0/telemetry.html)[ ] Horde (https://github.com/derekkraan/horde/blob/master/lib/horde/supervisor_telemetry_poller.ex)[ ] Cachex (Need to open up PR)Database cron based metrics:[ ] Postgres (https://github.com/pawurb/ecto_psql_extras for inspiration)[ ] MySQL (https://github.com/prometheus/mysqld_exporter)[ ] Redis (https://github.com/oliver006/redis_exporter)[ ] MongoDB (https://github.com/percona/mongodb_exporter)Each plugin also has an accompanying Grafana dashboard that you can leverage to plot all of the captured data (see each project's GitHub repo for details).In order to expose captured metrics, you can leverage the PromEx provided Plug found here (for use with Phoenix) PromEx.Plug. See that modules' documentation for specifics on how to use it.","ref":"PromEx.html","title":"PromEx","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"PromEx.html#child_spec/1","title":"PromEx.child_spec/1","type":"function"},{"doc":"The event_metrics/1 callback returns the configured event based metrics that the plugin exposes. If the plugin does not expose any event style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any event style metrics, there is no action needed on your part.This function is expected to either return a single PromEx.Plugins.Event struct or a list of PromEx.Plugins.Event structs.","ref":"PromEx.html#c:event_metrics/1","title":"PromEx.event_metrics/1","type":"callback"},{"doc":"A simple pass-through to fetch all of the currently configured metrics. This is primarily used by the exporter plug to fetch all of the metrics so that they can be scraped.","ref":"PromEx.html#get_metrics/0","title":"PromEx.get_metrics/0","type":"function"},{"doc":"The manual_metrics/1 callback returns the configured manual based metrics that the plugin exposes. If the plugin does not expose any manual style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any manual style metrics, there is no action needed on your part.This function is expected to either return a single PromEx.Plugins.Manual struct or a list of PromEx.Plugins.Manual structs.","ref":"PromEx.html#c:manual_metrics/1","title":"PromEx.manual_metrics/1","type":"callback"},{"doc":"The polling_metrics/1 callback returns the configured polling based metrics that the plugin exposes. If the plugin does not expose any polling style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any polling style metrics, there is no action needed on your part.This function is expected to either return a single PromEx.Plugins.Polling struct or a list of PromEx.Plugins.Polling structs.","ref":"PromEx.html#c:polling_metrics/1","title":"PromEx.polling_metrics/1","type":"callback"},{"doc":"Starts a PromEx process with the provided plugins initialized.Options:plugins - The list of plugin modules that you would like PromEx to initialize. Each plugin definition can either be a two element tuple with the structure {PlugIn.Module, keyword: &quot;list&quot;, of: &quot;options&quot;} or just the module name PlugIn.Module. Be sure to check the documentation for each plugin that you are using to ensure that you satisfy any required option fields.:delay_manual_start - Manual metrics are gathered once on start up and then only when you call PromEx.ManualMetricsManager.refresh_metrics(). Sometimes, you may have metrics that require your entire supervision tree to be started in order to fetch accurate data. This option will allow you to delays the initial metrics capture of the ManualMetricsManager by a certain number of milliseconds or the :no_delay atom if you want the metrics to be captured as soon as the ManualMetricsManager starts up.","ref":"PromEx.html#start_link/1","title":"PromEx.start_link/1","type":"function"},{"doc":"","ref":"PromEx.html#t:measurements_mfa/0","title":"PromEx.measurements_mfa/0","type":"type"},{"doc":"","ref":"PromEx.html#t:telemetry_metrics/0","title":"PromEx.telemetry_metrics/0","type":"type"},{"doc":"This module provides functions to generate histogram bucket ranges. The lists of buckets that can be generated are either linear or exponential.","ref":"PromEx.BucketGenerator.html","title":"PromEx.BucketGenerator","type":"module"},{"doc":"Create a linear set of buckets based on the provided parameters.Examplesiex&gt; PromEx.BucketGenerator.exponential(1, 4, 10) [1, 4, 16, 64, 256, 1024, 4096, 16384, 65536, 262144] iex&gt; PromEx.BucketGenerator.exponential(1, 2, 10) [1, 2, 4, 8, 16, 32, 64, 128, 256, 512]","ref":"PromEx.BucketGenerator.html#exponential/3","title":"PromEx.BucketGenerator.exponential/3","type":"function"},{"doc":"Create a linear set of buckets based on the provided parameters.Examplesiex&gt; PromEx.BucketGenerator.linear(10, 10, 10) [10, 20, 30, 40, 50, 60, 70, 80, 90, 100] iex&gt; PromEx.BucketGenerator.linear(0, 250, 11) [0, 250, 500, 750, 1000, 1250, 1500, 1750, 2000, 2250, 2500]","ref":"PromEx.BucketGenerator.html#linear/3","title":"PromEx.BucketGenerator.linear/3","type":"function"},{"doc":"This is a convenience module used for debugging and introspecting telemetry events. Primarily used to ease for development or PromEx itself.","ref":"PromEx.Debug.html","title":"PromEx.Debug","type":"module"},{"doc":"Use this function to attach a debugger handler to a certain telemetry event. This function will also return the","ref":"PromEx.Debug.html#attach_debugger/1","title":"PromEx.Debug.attach_debugger/1","type":"function"},{"doc":"This GenServer is responsible to keeping track of all the manual metrics from your configured plugins. It will fetch metrics initially when starting (either immediately or after a configured delay). At that point if you would like to refresh your metrics data points call the refresh_metrics/0 function.","ref":"PromEx.ManualMetricsManager.html","title":"PromEx.ManualMetricsManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"PromEx.ManualMetricsManager.html#child_spec/1","title":"PromEx.ManualMetricsManager.child_spec/1","type":"function"},{"doc":"This function calls into the GenServer and refreshes all of the configured manual metrics data points.","ref":"PromEx.ManualMetricsManager.html#refresh_metrics/0","title":"PromEx.ManualMetricsManager.refresh_metrics/0","type":"function"},{"doc":"","ref":"PromEx.ManualMetricsManager.html#start_link/1","title":"PromEx.ManualMetricsManager.start_link/1","type":"function"},{"doc":"This struct defines the fields necessary to export a group of standard metrics from a plugin.","ref":"PromEx.MetricTypes.Event.html","title":"PromEx.MetricTypes.Event","type":"module"},{"doc":"Create a struct that encompasses a group of event based metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_event_metrics. For example, Phoenix HTTP related metrics have a group_name of: :phoenix_http_event_metrics","ref":"PromEx.MetricTypes.Event.html#build/2","title":"PromEx.MetricTypes.Event.build/2","type":"function"},{"doc":"group_name: A unique identifier for the collection of metrics.metrics: A list of Telemetry Metrics structs that define the metrics.","ref":"PromEx.MetricTypes.Event.html#t:t/0","title":"PromEx.MetricTypes.Event.t/0","type":"type"},{"doc":"This struct defines the fields necessary to export a group of manually collected metric sources from a plugin.","ref":"PromEx.MetricTypes.Manual.html","title":"PromEx.MetricTypes.Manual","type":"module"},{"doc":"Create a struct that encompasses a group of manually triggered metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_manual_metrics. For example, Application related info metrics have a group_name of: :application_versions_manual_metrics","ref":"PromEx.MetricTypes.Manual.html#build/3","title":"PromEx.MetricTypes.Manual.build/3","type":"function"},{"doc":"group_name: A unique identifier for the collection of metrics.measurements_mfa: An MFA tuple that defines what function will be executed that will emit Telemetry events.metrics: A list of Telemetry Metrics structs that define the metrics.","ref":"PromEx.MetricTypes.Manual.html#t:t/0","title":"PromEx.MetricTypes.Manual.t/0","type":"type"},{"doc":"This struct defines the fields necessary to export a group of pollable metric sources from a plugin.","ref":"PromEx.MetricTypes.Polling.html","title":"PromEx.MetricTypes.Polling","type":"module"},{"doc":"Create a struct that encompasses a group of polling type metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_manual_metrics. For example, BEAM related memory metrics have a group_name of: :beam_memory_polling_events","ref":"PromEx.MetricTypes.Polling.html#build/4","title":"PromEx.MetricTypes.Polling.build/4","type":"function"},{"doc":"group_name: A unique identifier for the collection of metrics.measurements_mfa: An MFA tuple that defines what function will be executed that will emit Telemetry events.metrics: A list of Telemetry Metrics structs that define the metrics.poll_rate: An integer representing the millisecond between metrics samples.","ref":"PromEx.MetricTypes.Polling.html#t:t/0","title":"PromEx.MetricTypes.Polling.t/0","type":"type"},{"doc":"Use this plug in your Endpoint file to expose your metrics. The following options are supported by this plug:path: The path through which your metrics can be accessed (default is &quot;/metrics&quot;)If you need to have some sort of access control around your metrics endpoint, I would suggest looking at another library that I maintain called Unplug(https://hex.pm/packages/unplug). Using Unplug you can skip over this plug if some sort of requirement is not fulfilled. For example, if you wanted to configure the metrics endpoint to only be accessible if the request has an Authorization header that matches a configured environment variable you could do something like so using Unplug:defmodule MyApp.UnplugPredicates.SecureMetricsEndpoint do @behaviour Unplug.Predicate @impl true def call(conn, env_var) do auth_header = Plug.Conn.get_req_header(conn, &quot;authorization&quot;) System.get_env(env_var) == auth_header end endWhich can then be used in your endpoint.ex file like so:plug Unplug, if: {MyApp.UnplugPredicates.SecureMetricsEndpoint, &quot;PROMETHEUS_AUTH_SECRET&quot;}, do: PromEx.PlugThe reason that this functionality is not part of PromEx itself is that how you chose to configure the visibility of the metrics route is entirely up to the user and so it felt as though this plug would be over complicated by having to support application config, environment variables, etc. And given that Unplug exists for this purpose, it is the recommended tool for the job.","ref":"PromEx.Plug.html","title":"PromEx.Plug","type":"module"},{"doc":"This plugin captures metrics regarding your application, and its dependencies. Specifically, it captures the versions of your application and the application dependencies and also how many modules each depepndency is bringing into the project.This module supports the following options:otp_app: This is a REQUIRED option and is the name of you application in snake case (E.g. :my_cool_app).deps: This option is OPTIONAL and defines what dependencies the plugin should track. A value of :all means that PromEx will fetch details on all application dependencies. A list of dependency names like [:phoenix, :ecto, :unplug] means that PromEx will only fetch details regarding those dependencies.To use plugin in your application, add the following to your application supervision tree:def start(_type, _args) do children = [ ... { PromEx, plugins: [ {PromEx.Plugins.Application, [otp_app: :my_cool_app]}, ... ], delay_manual_start: :no_delay } ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [strategy: :one_for_one, name: WebApp.Supervisor] Supervisor.start_link(children, opts) endThis plugin exposes manual metrics so be sure to configure the PromEx :delay_manual_start as required.","ref":"PromEx.Plugins.Application.html","title":"PromEx.Plugins.Application","type":"module"},{"doc":"Telemetry metrics for the BEAM.#TODO: More indepth docs coming","ref":"PromEx.Plugins.Beam.html","title":"PromEx.Plugins.Beam","type":"module"},{"doc":"Telemetry events for: https://hexdocs.pm/phoenix/Phoenix.Logger.html#TODO: More indepth docs coming","ref":"PromEx.Plugins.Phoenix.html","title":"PromEx.Plugins.Phoenix","type":"module"},{"doc":"Prometheus Reporter for Telemetry.Metrics definitions.Provide a list of metric definitions to the child_spec/1 function. It's recommended to add this to your supervision tree.def start(_type, _args) do # List all child processes to be supervised children = [ {PromEx.TelemetryMetricsPrometheus.Core, [ metrics: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ] ]} ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) endNote that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it's recommended at this time to keep an eye on scrape durations if you're reporting a large number of distributions or you have a high tag cardinality.Telemetry.Metrics to Prometheus EquivalentsMetric types:Counter - CounterDistribution - HistogramLastValue - GaugeSum - CounterSummary - Summary (Not supported)UnitsPrometheus recommends the usage of base units for compatibility - Base Units. This is simple to do with :telemetry and Telemetry.Metrics as all memory related measurements in the BEAM are reported in bytes and Metrics provides automatic time unit conversions.Note that measurement unit should used as part of the reported name in the case of histograms and gauges to Prometheus. As such, it is important to explicitly define the unit of measure for these types when the unit is time or memory related.It is suggested to not mix units, e.g. seconds with milliseconds.It is required to define your buckets according to the end unit translation since this measurements are converted at the time of handling the event, prior to bucketing.MemoryReport memory as :byte.TimeReport durations as :second. The BEAM and :telemetry events use :native time units. Converting to seconds is as simple as adding the conversion tuple for the unit - {:native, :second}NamingTelemetry.Metrics definition names do not translate easily to Prometheus naming conventions. By default, the name provided when creating your definition uses parts of the provided name to determine what event to listen to and which event measurement to use.For example, &quot;http.request.duration&quot; results in listening for [:http, :request] events and use :duration from the event measurements. Prometheus would recommend a name of http_request_duration_seconds as a good name.It is therefore recommended to use the name in your definition to reflect the name you wish to see reported, e.g. http.request.duration.seconds or [:http, :request, :duration, :seconds] and use the :event_name override and :measurement options in your definition.Example:Metrics.distribution( &quot;http.request.duration.seconds&quot;, event_name: [:http, :request, :complete], measurement: :duration, unit: {:native, :second}, reporter_options: [ buckets: [0.01, 0.025, 0.05, 0.1, 0.2, 0.5, 1] ] )The exporter sanitizes names to Prometheus' requirements (Metric Naming) and joins the event name parts with an underscore.LabelsLabels in Prometheus are referred to as :tags in Telemetry.Metrics - see the docs for more information on tag usage.Important: Each tag + value results in a separate time series. For distributions, this is further complicated as a time series is created for each bucket plus one for measurements exceeding the limit of the last bucket - +Inf.It is recommended, but not required, to abide by Prometheus' best practices regarding labels - Label Best PracticesMissing or Invalid Measurements and TagsIf a measurement value is missing or non-numeric, the error is logged at the debug level and the event is not recorded. Events with missing tags are also logged and skipped.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html","title":"PromEx.TelemetryMetricsPrometheus.Core","type":"module"},{"doc":"Reporter's child spec.This function allows you to start the reporter under a supervisor like this:children = [ {PromEx.TelemetryMetricsPrometheus.Core, options} ]See start_child/1 for options.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#child_spec/1","title":"PromEx.TelemetryMetricsPrometheus.Core.child_spec/1","type":"function"},{"doc":"Returns a metrics scrape in Prometheus exposition format for the given reporter name - defaults to :prometheus_metrics.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#scrape/1","title":"PromEx.TelemetryMetricsPrometheus.Core.scrape/1","type":"function"},{"doc":"Start the PromEx.TelemetryMetricsPrometheus.Core.SupervisorAvailable options::name - name of the reporter instance. Defaults to :prometheus_metrics:metrics - a list of metrics to track.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#start_link/1","title":"PromEx.TelemetryMetricsPrometheus.Core.start_link/1","type":"function"},{"doc":"","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#t:metrics/0","title":"PromEx.TelemetryMetricsPrometheus.Core.metrics/0","type":"type"},{"doc":"","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#t:prometheus_option/0","title":"PromEx.TelemetryMetricsPrometheus.Core.prometheus_option/0","type":"type"},{"doc":"","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#t:prometheus_options/0","title":"PromEx.TelemetryMetricsPrometheus.Core.prometheus_options/0","type":"type"},{"doc":"PromEx An Elixir Prometheus metrics collection library built on top of Telemetry","ref":"readme.html","title":"PromEx","type":"extras"},{"doc":"This library is still under active development with changing API contracts and forked dependencies...use at your own risk for now :).Available in Hex, the package can be installed by adding prom_ex to your list of dependencies in mix.exs:def deps do [ {:prom_ex, &quot;~&gt; 0.1.0&quot;} ] endDocumentation can be found at https://hexdocs.pm/prom_ex.Design PhilosophyWith the widespread adoption of the Telemetry library and the other libraries in the BEAM Telemetry GitHub Org, we have reached a point where we have a consistent means of surfacing application metrics. This allows us to have a great level of insight into our applications and dependencies given that they all leverage the same fundamental tooling. The goal of this project is to provide a &quot;Plug-in&quot; style library where you can easily add new plug-ins to surface metrics so that Prometheus can scrape them. Ideally, this project acts as the &quot;Metrics&quot; pillar in your application (in reference to The Three Pillars of Observability).PromEx provides a few utilities to you in order to accomplish this goal:A behaviour that defines the contract for PromEx plug-insMix tasks to upload the provided complimentary Grafana dashboardsThe PromEx.MetricTypes.Event struct to define event based metricsThe PromEx.MetricTypes.Polling struct to define pollable metricsThe PromEx.MetricTypes.Manual struct to define manually refreshed metricsThe PromEx.Plug module that can be used in your Phoenix or Plug application to expose the collected metricsAvailable PluginsPluginStatusDescriptionPromEx.Plugins.ApplicationAlphaCollect metrics on your application dependenciesPromEx.Plugins.BeamAlphaCollect metrics regarding the BEAM virtual machinePromEx.Plugins.PhoenixAlphaCollect request metrics emitted by PhoenixPromEx.Plugins.EctoComing soonCollect query metrics emitted by EctoPromEx.Plugins.BroadwayComing soonCollect message processing metrics emitted by BroadwayPromEx.Plugins.FinchComing soonCollect HTTP request metrics emitted by FinchMore coming soon...Setting Up MetricsThe goal of PromEx is to have metrics set up be as simple and streamlined as possible. In that spirit, all that you need to do to start leveraging PromEx along with the built-in plugins is the following in your application.ex file:defmodule MyCoolApp.Application do use Application def start(_type, _args) do children = [ ... { PromEx, plugins: [ {PromEx.Plugins.Phoenix, router: MyCoolAppWeb.Router}, PromEx.Plugins.Beam, {PromEx.Plugins.Application, [otp_app: :my_cool_app]}, # Any additional PromEx plugins you would like to enable ] } ] opts = [strategy: :one_for_one, name: MyCoolApp.Supervisor] Supervisor.start_link(children, opts) end endWith that in place, all that you need to do is then add the PromEx plug somewhere in your endpoint.ex file (I would suggest putting it before your plug Plug.Telemetry call so that you do not pollute your logs with calls to /metrics):defmodule MyCoolAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_cool_app ... plug PromEx.Plug # Or plug PromEx.plug, path: &quot;/some/other/non-standard/path&quot; ... plug Plug.RequestId plug Plug.Telemetry, event_prefix: [:phoenix, :endpoint] ... plug MyCoolAppWeb.Router endWith that in place, all you need to do is start your server and you should be able to hit your metrics endpoint and see your application metrics:$ curl localhost:4000/metrics # HELP my_cool_app_application_dependency_info Information regarding the application's dependencies. # TYPE my_cool_app_application_dependency_info gauge my_cool_app_application_dependency_info{modules=&quot;69&quot;,name=&quot;hex&quot;,version=&quot;0.20.5&quot;} 1 my_cool_app_application_dependency_info{modules=&quot;1&quot;,name=&quot;connection&quot;,version=&quot;1.0.4&quot;} 1 my_cool_app_application_dependency_info{modules=&quot;4&quot;,name=&quot;telemetry_poller&quot;,version=&quot;0.5.1&quot;} 1 ... ...Be sure to check out the module docs for each plugin that you choose to use to ensure that you are familiar with all of the options that they provide.AttributionIt wouldn't be right to not include somewhere in this project a &quot;thanks&quot; to the various projects that helped make this possible:The various projects available in BEAM TelemetryAll of the Prometheus libraries that Ilya Khaprov (@deadtrickster) maintainsThe logo for the project is an edited version of an SVG image from the unDraw project","ref":"readme.html#installation","title":"PromEx - Installation","type":"extras"},{"doc":"Writing PromEx PluginsThis guide will walk you through writing a PromEx plugin. Whether this plugin is for a dependent library or for your internal application metrics, the same patterns apply.","ref":"writing-promex-plugins.html","title":"Writing PromEx Plugins","type":"extras"},{"doc":"In order for PromEx to be able to load the appropriate metrics from your plugins, your modules need to leverage the PromEx behaviour. This behaviour defines 3 optional callbacks. Those callbacks are: event_metrics/1 polling_metrics/1 manual_metrics/1Each of these callbacks is supposed to return a list of metrics of that type. For example, polling_metrics/1 needs to return a list of PromEx.MetricTypes.Polling structs (a single struct is also an acceptable return). By doing this, you plugin can load your metrics and deal with the nuances of each metric type properly. Each of the MetricTypes structs all have a field called :metrics. This field contains a list of all the Telemetry.Metrics definitions that were provided to the struct build function.","ref":"writing-promex-plugins.html#getting-started","title":"Writing PromEx Plugins - Getting started","type":"extras"},{"doc":"To have your custom plugin expose event based metrics, implement a event_metrics/1 function and build our a collection of Telemetry.Metrics structs (distribution, counter, last_value, and sum). Be sure to look at plugins like PromEx.Plugins.Phoenix for more in depth examples.defmodule MyApp.PromEx.Plugins.MyPhoenix do use PromEx @impl true def event_metrics(opts) do http_metrics_tags = gen_http_metrics_tags(opts) phoenix_router = get_phoenix_router(opts) phoenix_stop_event = [:phoenix, :endpoint, :stop] Event.build( :phoenix_http_event_metrics, [ # Capture request duration information distribution( [:phoenix, :http, :request, :duration, :milliseconds], event_name: phoenix_stop_event, measurement: :duration, description: &quot;The time it takes for the application to respond to HTTP requests.&quot;, reporter_options: [ buckets: exponential(1, 2, 12) ], tag_values: get_conn_tags(phoenix_router), tags: http_metrics_tags, unit: {:native, :millisecond} ) # Additional event based metrics ... ] ) end end","ref":"writing-promex-plugins.html#adding-event-metrics","title":"Writing PromEx Plugins - Adding Event Metrics","type":"extras"},{"doc":"Polling metrics are similar to event metrics in that they require similar fields (group_name and metrics to be specific). In addition, the PromEx.MetricTypes.Polling.build/4 function requires an measurements_mfa argument which specifies what function will be executed on the polling interval. This function should run :telemetry.execute/3 somewhere in its function body. Once that event is executed, the corresponding event in the struct will be triggered and you will capture the desired data point. The following example from PromEx.Plugins.Beam should highlight this concept:defmodule PromEx.Plugins.Beam do use PromEx @memory_event [:prom_ex, :plugin, :beam, :memory] @impl true def polling_metrics(opts) do poll_rate = Keyword.get(opts, :poll_rate, 5_000) [ memory_metrics(poll_rate) ] end defp memory_metrics(poll_rate) do Polling.build( :beam_memory_polling_events, poll_rate, {__MODULE__, :execute_memory_metrics, []}, [ # Capture the total memory allocated to the entire Erlang VM (or BEAM for short) last_value( [:beam, :memory, :total, :kilobytes], event_name: @memory_event, description: &quot;The total amount of memory currently allocated.&quot;, measurement: :total, unit: {:byte, :kilobyte} ) # More memory metrics here ] ) end @doc false def execute_memory_metrics do memory_measurements = :erlang.memory() |&gt; Map.new() :telemetry.execute(@memory_event, memory_measurements, %{}) end endDepending on what :poll_rate value you pass to the initialization tuple for PromEx.Plugins.Beam, the execute_memory_metrics/0 function will be execute on that specified interval.","ref":"writing-promex-plugins.html#adding-polling-metrics","title":"Writing PromEx Plugins - Adding Polling Metrics","type":"extras"},{"doc":"Manual metrics behave more or less the same as polling metrics except they do not require a poll rate value. Instead the provided measurements_mfa is called once on application start, and the metrics are only then updated if you make a call to PromEx.ManualMetricsManager.refresh_metrics/0. An example of this can be seen from the PromEx.Plugins.Application plugin:defmodule PromEx.Plugins.Application do use PromEx @impl true def manual_metrics(opts) do otp_app = Keyword.fetch!(opts, :otp_app) apps = Keyword.get(opts, :deps, :all) Manual.build( :application_versions_manual_metrics, {__MODULE__, :apps_running, [otp_app, apps]}, [ # Capture information regarding the primary application (i.e the user&#39;s application) last_value( [otp_app | [:application, :primary, :info]], event_name: [otp_app | [:application, :primary, :info]], description: &quot;Information regarding the primary application.&quot;, measurement: :status, tags: [:name, :version, :modules] ) # Additional metrics here ] ) end @doc false def apps_running(otp_app, apps) do ... # Emit primary app details :telemetry.execute( [otp_app | [:application, :primary, :info]], %{ status: if(Map.has_key?(started_apps, otp_app), do: 1, else: 0) }, %{ name: otp_app, version: Map.get_lazy(started_apps, otp_app, fn -&gt; Map.get(loaded_only_apps, otp_app, &quot;undefined&quot;) end), modules: length(Application.spec(otp_app)[:modules]) } ) end endSo in this example, apps_running/2 is the function that is denoted by the MFA and will be called once automatically on application start, but then at that point it is up to the user to refresh the data point.","ref":"writing-promex-plugins.html#adding-manual-metrics","title":"Writing PromEx Plugins - Adding Manual Metrics","type":"extras"}]